VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cXMLConfig"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

'local variable(s) to hold property value(s)
Private mvarFileName As String 'local copy
Private mXMLDocument As MSXML.DOMDocument
Private mXMLDocRoot As MSXML.IXMLDOMNode
Public Sub Sync()
' --------------------------------------------------------
' Purpose      :Save our file
' Inputs       :
' Return Value : None
' Developer    : JBAILEY
' Mod Dates    :
' Called From  :
' Created      : Friday, May 04, 2001 02:06:18 PM
' --------------------------------------------------------
On Error GoTo Sync_Error

    'Declarations

    
    If mXMLDocument Is Nothing Then
        Exit Sub
    End If
    'Save our results
    mXMLDocument.save mvarFileName

Sync_Exit:
    Exit Sub

Sync_Error:
    Select Case Err.Number
        Case Else
            Err.Raise Err.Number, "Sync", Err.Description & "Sync"
            Resume Sync_Exit
    End Select
End Sub

Public Function DeleteSetting(ByVal sSection As String, ByVal sKeyName As String, Optional bSkipSave As Boolean) As Boolean
' --------------------------------------------------------
' Purpose      :Returns true if a setting was deleted
' Inputs       :
' Return Value : Boolean
' Developer    : JBAILEY
' Mod Dates    :
' Called From  :
' Created      : Wednesday, May 02, 2001 12:45:14 PM
' --------------------------------------------------------
On Error GoTo DeleteSetting_Error

    'Declarations
    Dim oXMLKeyBlock As MSXML.IXMLDOMNode
    
    If mXMLDocument Is Nothing Then
        Exit Function
    End If
    
    
    'Find the key node if it exists
    Set oXMLKeyBlock = mXMLDocRoot.selectSingleNode("//SECTION[NAME = '" & sSection & "']/KEYLIST/KEY[NAME = '" & sKeyName & "']")
    
    If oXMLKeyBlock Is Nothing Then
        DeleteSetting = False
    Else
    
        'Delete the key block
        oXMLKeyBlock.parentNode.removeChild oXMLKeyBlock
        
        If bSkipSave = False Then
            'Save our results
            mXMLDocument.save mvarFileName
        End If
        
        DeleteSetting = True
    End If

DeleteSetting_Exit:
    Exit Function

DeleteSetting_Error:
    Select Case Err.Number
        Case Else
            Err.Raise Err.Number, "DeleteSetting", Err.Description & "DeleteSetting"
            Resume DeleteSetting_Exit
    End Select
End Function

Public Function SaveSetting(ByVal sSection As String, ByVal sKeyName As String, ByVal sValue As String, Optional bSkipSave As Boolean) As Boolean
' --------------------------------------------------------
' Purpose      :Returns true if the setting already existed and was overwriten
' Inputs       :
' Return Value : Boolean
' Developer    : JBAILEY
' Mod Dates    :
' Called From  :
' Created      : Wednesday, May 02, 2001 03:54:12 PM
' --------------------------------------------------------
On Error GoTo SaveSetting_Error

    'Declarations
    Dim oXMLKeyBlock As MSXML.IXMLDOMNode
    Dim oXMLSection As MSXML.IXMLDOMNode
    Dim oXMLKeyValue As MSXML.IXMLDOMNode
    Dim oXMLNewNode As MSXML.IXMLDOMNode
    
    If mXMLDocument Is Nothing Then
        Exit Function
    End If
    
    'Find the key value if it exists
    Set oXMLKeyValue = mXMLDocRoot.selectSingleNode("//SECTION[NAME = '" & sSection & "']/KEYLIST/KEY[NAME = '" & sKeyName & "']/VALUE")
        
    'Check to see if this setting exists
    If oXMLKeyValue Is Nothing Then

        'Get the section
        Set oXMLSection = mXMLDocRoot.selectSingleNode("//SECTION[NAME = '" & sSection & "']/KEYLIST")
        If oXMLSection Is Nothing Then  'The section doesn't exist
            Set oXMLSection = mXMLDocRoot.selectSingleNode("/INISCHEMA/SECTIONLIST")
            'Add the section node
            Set oXMLNewNode = mXMLDocument.createNode(NODE_ELEMENT, "SECTION", "")
            Set oXMLSection = oXMLSection.appendChild(oXMLNewNode)
            
            'Add the name node
            Set oXMLNewNode = mXMLDocument.createNode(NODE_ELEMENT, "NAME", "")
            oXMLNewNode.Text = sSection
            Call oXMLSection.appendChild(oXMLNewNode)
            
            'Add the keylist block
            Set oXMLNewNode = mXMLDocument.createNode(NODE_ELEMENT, "KEYLIST", "")
            Set oXMLSection = oXMLSection.appendChild(oXMLNewNode)
        End If
        
        'Add the Key node block
        Set oXMLNewNode = mXMLDocument.createNode(NODE_ELEMENT, "KEY", "")
        Set oXMLKeyBlock = oXMLSection.appendChild(oXMLNewNode)
        
        'Create the key name
        Set oXMLNewNode = mXMLDocument.createNode(NODE_ELEMENT, "NAME", "")
        oXMLNewNode.Text = sKeyName
        Call oXMLKeyBlock.appendChild(oXMLNewNode)
        
        'Create the key value
        Set oXMLNewNode = mXMLDocument.createNode(NODE_ELEMENT, "VALUE", "")
        oXMLNewNode.Text = sValue
        oXMLKeyBlock.appendChild oXMLNewNode
    
    Else    'The setting does exist, just update it
        
        oXMLKeyValue.Text = sValue
        
        SaveSetting = True
    End If
    
    If bSkipSave = False Then
        mXMLDocument.save mvarFileName
    End If
SaveSetting_Exit:
    Exit Function

SaveSetting_Error:
    Select Case Err.Number
        Case Else
            Err.Raise Err.Number, "SaveSetting", Err.Description & "SaveSetting"
            Resume SaveSetting_Exit
    End Select
End Function
Public Function GetSetting(ByVal sSection As String, ByVal sKeyName As String, Optional ByVal sDefaultValue As String) As String
' --------------------------------------------------------
' Purpose      :Returns the found setting or the default value if not found
' Inputs       :
' Return Value : None
' Developer    : JBAILEY
' Mod Dates    :
' Called From  :
' Created      : Tuesday, May 01, 2001 01:43:24 PM
' --------------------------------------------------------
On Error GoTo GetSetting_Error

    'Declarations
    Dim oXMLKeyValue As MSXML.IXMLDOMNode
    
    If mXMLDocument Is Nothing Then
        Exit Function
    End If
    
    'Find the key value if it exists
    Set oXMLKeyValue = mXMLDocRoot.selectSingleNode("//SECTION[NAME = '" & sSection & "']/KEYLIST/KEY[NAME = '" & sKeyName & "']/VALUE")
    
    If oXMLKeyValue Is Nothing Then
        GetSetting = sDefaultValue
    Else
        GetSetting = oXMLKeyValue.Text
    End If
    
GetSetting_Exit:
    Exit Function

GetSetting_Error:
    Select Case Err.Number
        Case Else
            Err.Raise Err.Number, "GetSetting", Err.Description & "GetSetting"
            Resume GetSetting_Exit
    End Select
End Function

Public Function GetSection(ByVal sSection As String, _
                              ByRef sKeyArray() As String, _
                              ByRef sValueArray() As String) As Integer
' --------------------------------------------------------
' Purpose      :Returns the number of items in the section
' Inputs       :
' Return Value : None
' Developer    : JBAILEY
' Mod Dates    :
' Called From  :
' Created      : Tuesday, May 01, 2001 01:43:24 PM
' --------------------------------------------------------
On Error GoTo GetSection_Error

    'Declarations

    Dim oXMLKeyBlock As MSXML.IXMLDOMNode
    Dim oXMLSection As MSXML.IXMLDOMNode
    Dim oXMLSECTIONLIST As MSXML.IXMLDOMNodeList
    Dim oXMLRoot As MSXML.IXMLDOMNode
    Dim oXMLKeyValue As MSXML.IXMLDOMNode
    Dim oXMLKeyName As MSXML.IXMLDOMNode
    Dim i As Integer
    Dim j As Integer


    If mXMLDocument Is Nothing Then
        Exit Function
    End If

    'Get the keylist block
    Set oXMLKeyBlock = mXMLDocRoot.selectSingleNode("//SECTION[NAME = '" & sSection & "']/KEYLIST")
    If oXMLKeyBlock Is Nothing Then
        GoTo GetSection_Exit
    End If

    ReDim sKeyArray(0)
    ReDim sValueArray(0)
    
    For i = 0 To oXMLKeyBlock.childNodes.length
        Set oXMLKeyName = oXMLKeyBlock.selectSingleNode("KEY/NAME")

        If Not oXMLKeyName Is Nothing Then
            ReDim Preserve sKeyArray(j)
            ReDim Preserve sValueArray(j)
            
            sKeyArray(j) = oXMLKeyName.Text
            
            Set oXMLKeyValue = oXMLKeyBlock.selectSingleNode("KEY/VALUE")
            
            sValueArray(j) = oXMLKeyValue.Text
            
            j = j + 1
        
        End If
    
    Next i

    GetSection = j

GetSection_Exit:
    Exit Function

GetSection_Error:
    Select Case Err.Number
        Case Else
            Err.Raise Err.Number, "GetSection", Err.Description & "GetSection"
            Resume GetSection_Exit
    End Select
End Function

Public Function DeleteSection(ByVal sSection As String, Optional bSkipSave As Boolean) As Boolean
' --------------------------------------------------------
' Purpose      :Returns true if the section was deleted
' Inputs       :
' Return Value : boolean
' Developer    : JBAILEY
' Mod Dates    :
' Called From  :
' Created      : Wednesday, May 02, 2001 01:24:56 PM
' --------------------------------------------------------
On Error GoTo DeleteSection_Error

    'Declarations
    Dim oXMLSection As MSXML.IXMLDOMNode

    If mXMLDocument Is Nothing Then
        Exit Function
    End If

    'Get the section
    Set oXMLSection = mXMLDocRoot.selectSingleNode("//SECTION[NAME = '" & sSection & "']")
    If oXMLSection Is Nothing Then
        GoTo DeleteSection_Exit
    End If

    'Delete the  block
    oXMLSection.parentNode.removeChild oXMLSection
    
    If bSkipSave = False Then
        'Save our results
        mXMLDocument.save mvarFileName
    End If
    

DeleteSection_Exit:
    Exit Function

DeleteSection_Error:
    Select Case Err.Number
        Case Else
            Err.Raise Err.Number, "DeleteSection", Err.Description & "DeleteSection"
            Resume DeleteSection_Exit
    End Select
End Function



Public Property Let FileName(ByVal vData As String)
'used when assigning a value to the property, on the left side of an assignment.
'Syntax: X.FileName = 5
    Dim oNode As MSXML.IXMLDOMNode
    Dim oXMLBlock As MSXML.IXMLDOMNode
    Dim oXMLSECTIONLISTBlock As MSXML.IXMLDOMNode
    Dim oXMLDocument As New MSXML.DOMDocument

    mvarFileName = vData
    Set mXMLDocument = New DOMDocument
    mXMLDocument.Load vData
    
    'If the document element is nothing then we don't have a file yet.  Create the base file
    If mXMLDocument.documentElement Is Nothing Then
        Set oNode = mXMLDocument.createNode(NODE_ELEMENT, "INISCHEMA", "")
        Set oXMLBlock = mXMLDocument.appendChild(oNode)
        Set oNode = mXMLDocument.createNode(NODE_ELEMENT, "SECTIONLIST", "")
        Set oXMLSECTIONLISTBlock = oXMLBlock.appendChild(oNode)
        mXMLDocument.save mvarFileName
    End If
    
    Set mXMLDocRoot = mXMLDocument.documentElement
End Property


Public Property Get FileName() As String
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.FileName
    FileName = mvarFileName
End Property


Public Function ConvertINIToXML(sINIFile As String, sXMLFile As String) As Boolean
' --------------------------------------------------------
' Purpose      :
' Inputs       :
' Return Value : Boolean
' Developer    : Brian Bender
' Mod Dates    :
' Called From  :
' Created      : 2/7/01
' --------------------------------------------------------
On Error GoTo ConvertINIToXML_Error

    'Declarations

    Dim iFile As Integer
    Dim oXMLDocument As New MSXML.DOMDocument
    Dim oXMLBlock As MSXML.IXMLDOMNode
    Dim oXMLSECTIONLISTBlock As MSXML.IXMLDOMNode
    Dim oXMLSectionBlock As MSXML.IXMLDOMNode
    Dim oXMLKeyListBlock As MSXML.IXMLDOMNode
    Dim oXMLKeyBlock As MSXML.IXMLDOMNode
    Dim oNode As MSXML.IXMLDOMNode
    '-- Create Initial Blocks
    Set oNode = oXMLDocument.createNode(NODE_ELEMENT, "INISCHEMA", "")
    Set oXMLBlock = oXMLDocument.appendChild(oNode)
    Set oNode = oXMLDocument.createNode(NODE_ELEMENT, "SECTIONLIST", "")
    Set oXMLSECTIONLISTBlock = oXMLBlock.appendChild(oNode)

    iFile = FreeFile
    Dim sWorking As String
    Dim iCount As Integer
    
    On Error Resume Next
    Open Trim(sINIFile) For Input As iFile
    If Err.Number = 53 Then
        Exit Function
    End If
    On Error GoTo ConvertINIToXML_Error
    
    Do Until EOF(iFile)
        Line Input #iFile, sWorking
        sWorking = Trim(sWorking)


        If Left$(sWorking, 1) = "[" And Right$(sWorking, 1) = "]" Then
            '-- Section Found Add to XML Document
            Set oNode = oXMLDocument.createNode(NODE_ELEMENT, "SECTION", "")
            Set oXMLSectionBlock = oXMLSECTIONLISTBlock.appendChild(oNode)
            Set oNode = oXMLDocument.createNode(NODE_ELEMENT, "NAME", "")
            oNode.Text = Mid$(sWorking, 2, Len(sWorking) - 2)
            oXMLSectionBlock.appendChild oNode
            
            '-- Get keys from current Section
            Dim iRetCode As Integer
            Dim sBuf As String
            Dim sSize As String
            Dim sKeys As String
            sBuf = Space$(1024)
            sSize = Len(sBuf)
            iRetCode = GetPrivateProfileSection(oNode.Text, sBuf, sSize, sINIFile)


            If (sSize > 0) Then
                sKeys = Left$(sBuf, iRetCode)
                Dim arKeys() As String
                Dim sKey As String
                Dim sValue As String
                arKeys = Split(sKeys, vbNullChar)


                If Not isArrayEmpty(arKeys) Then
                    '-- We have at least one Key so Build a
                    '     KeyList Block
                    Set oNode = oXMLDocument.createNode(NODE_ELEMENT, "KEYLIST", "")
                    Set oXMLKeyListBlock = oXMLSectionBlock.appendChild(oNode)
                    '-- Write a count tag and fill it in lat
                    '     er
                    'Set oNode = oXMLDocument.createNode(NODE_ELEMENT, "Count", "")
                    'oXMLKeyListBlock.appendChild oNode


                    For iCount = LBound(arKeys) To UBound(arKeys)


                        If arKeys(iCount) <> "" Then


                            If InStr(1, arKeys(iCount), "=") <> 0 Then
                                sKey = Left$(arKeys(iCount), InStr(1, arKeys(iCount), "=") - 1)
                                sValue = Right$(arKeys(iCount), Len(arKeys(iCount)) - InStr(1, arKeys(iCount), "="))
                            Else
                                sKey = arKeys(iCount)
                                sValue = ""
                            End If
                            Set oNode = oXMLDocument.createNode(NODE_ELEMENT, "KEY", "")
                            Set oXMLKeyBlock = oXMLKeyListBlock.appendChild(oNode)
                            Set oNode = oXMLDocument.createNode(NODE_ELEMENT, "NAME", "")
                            oNode.Text = sKey
                            oXMLKeyBlock.appendChild oNode
                            Set oNode = oXMLDocument.createNode(NODE_ELEMENT, "VALUE", "")
                            oNode.Text = sValue
                            oXMLKeyBlock.appendChild oNode
                        End If
                    Next

                End If
            Else
                sKeys = ""
            End If
        End If
    Loop

    Close iFile
    oXMLDocument.save sXMLFile
    ConvertINIToXML = True
ConvertINIToXML_Exit:
    Exit Function

ConvertINIToXML_Error:
    Select Case Err.Number
        Case Else
            Err.Raise Err.Number, "ConvertINIToXML", Err.Description & "ConvertINIToXML"
            Resume ConvertINIToXML_Exit
    End Select
End Function

Private Function isArrayEmpty(arr As Variant) As Boolean
    Dim i
    isArrayEmpty = True
    On Error Resume Next
    i = UBound(arr) ' cause an Error If array is empty
    If Err.Number > 0 Then Exit Function
    isArrayEmpty = False
End Function

Private Sub Class_Terminate()
    'Save our results
    mXMLDocument.save mvarFileName
End Sub
