VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "inq"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
'//  Author:    Mark Thorogood; Jan 07, 02
'//
'//  Purpose:   Implement a queue abstract data structure (using a collection).
'//             A queue is used store items in order of occurrence, and it
'//             retrieves those items on a FIFO (first-in, first-out) basis, a.k.a.
'//             FCFS (first-come, first-serve).
'//
'//  Notes:     This implemention of the queue using a collection corrects
'//             the memory bleed bug of earlier versions.  The queue can hold up
'//             to 32,767 items because an integer variable is used to track the
'//             the queue's length.
'//
'//  Methods:
'//             QAdd(ByVal sItem As String)
'//             QClear()
'//             QDelete()
'//             QRead()     '//  reads the front element and advances the pointer
'//                         '//  to the front element (decreases the queue length
'//                         '//  by one element;
'//             Class_Initialize()  --> constructor;
'//             Class_Terminate()   --> destructor;
'//
'//  Properties:
'//             QIsEmpty
'//             QLength
'//             QPeek       '//  reads the current element but does not advance the
'//                         '//  pointer to the front element;
'//
'//  Private Members:

    Dim m_oColl As Collection
    Dim m_iQLength As Integer
Private Sub Class_Initialize()
    Set m_oColl = New Collection
    m_iQLength = 0
End Sub


'//  ~Destructor;
Private Sub Class_Terminate()
    Set m_oColl = Nothing
End Sub


Public Sub QAdd(ByVal vItem As Variant)
If vItem = vbNull Then
Debug.Print "asdf"
Exit Sub
End If
    If m_iQLength < 32767 Then
        m_oColl.Add (vItem)
        m_iQLength = m_iQLength + 1
    Else
        MsgBox "Queue length exceeded.  Add method abended.", vbOKOnly _
            Or vbCritical, "MW&E Queue Class"
    End If
End Sub


Public Sub QClear()
    '//  Ensure that all memory is released;
    Set m_oColl = Nothing
    Set m_oColl = New Collection
    m_iQLength = 0
End Sub


Public Sub QDelete()
    If m_iQLength > 0 Then
        m_oColl.Remove (1)
        m_iQLength = m_iQLength - 1
    End If
End Sub


Public Property Get QIsEmpty() As Boolean
    If m_iQLength = 0 Then
        QIsEmpty = True
    Else
        QIsEmpty = False
    End If
End Property


Public Property Get QLength() As Integer
    QLength = m_iQLength
End Property


Public Property Get QPeek() As Variant
    If m_iQLength > 0 Then
        QPeek = m_oColl.Item(1)
    Else
        QPeek = Null
    End If
End Property


Public Property Get QRead() As Variant
    If m_iQLength > 0 Then
        QRead = m_oColl.Item(1)
        m_oColl.Remove (1)
        m_iQLength = m_iQLength - 1
    Else
        QRead = Null
    End If
End Property
