Attribute VB_Name = "modTrans"
'***Form Transparency example by JoeS

'***I saw an example of this once and decided to make my own
'***This shows you how to make a form completely transparent
'***with or without frames

'***Skill Level: Intermediate

'***Questions or comments to: pre@dosfx.com
'***http://www.dosfx.com/~pre

Option Explicit

'Declares
Public Declare Function SetWindowRgn Lib "user32" (ByVal hwnd As Long, ByVal hRgn As Long, ByVal bRedraw As Boolean) As Long
Public Declare Function CreateRectRgn Lib "gdi32" (ByVal X1 As Long, ByVal Y1 As Long, ByVal X2 As Long, ByVal Y2 As Long) As Long
Public Declare Function CombineRgn Lib "gdi32" (ByVal hDestRgn As Long, ByVal hSrcRgn1 As Long, ByVal hSrcRgn2 As Long, ByVal nCombineMode As Long) As Long

'Constants
Public Const RGN_OR = 2
Public Const RGN_DIFF = 4

'Public Long
Public lngRegion As Long
Public Function ChangeAppearance()
    
    Dim sngWidth As Single, sngHeight As Single, sngLeft As Single, sngTop As Single
    Dim varLeft As Variant, varTop As Variant
    Dim intPos As Integer, lngNew As Long, lngIn As Long, lngOut As Long
    
    'Set Form Height And Width To ScaleHeight And ScaleWidth
    sngWidth = frmmain.ScaleX(frmmain.Width, vbTwips, vbPixels)
    sngHeight = frmmain.ScaleY(frmmain.Height, vbTwips, vbPixels)
    
    'Set default region
    lngRegion = CreateRectRgn(0, 0, 0, 0)
    
    'Measure our frame edges
    sngLeft = (sngWidth - frmmain.ScaleWidth) / 2
    sngTop = sngHeight - sngLeft - frmmain.ScaleHeight
    lngOut = CreateRectRgn(0, 0, sngWidth, sngHeight)
    
    'Get our frame, because we want to show a frame with this one
    lngIn = CreateRectRgn(sngLeft, sngTop, sngWidth - sngLeft, sngHeight - sngLeft)
    'Combine our frame edge region with our frame region
    CombineRgn lngRegion, lngOut, lngIn, RGN_DIFF

    'Add our controls
    For intPos = 0 To frmmain.Controls.Count - 1
        varLeft = frmmain.ScaleX(frmmain.Controls(intPos).Left, frmmain.ScaleMode, vbPixels) + sngLeft
        varTop = frmmain.ScaleX(frmmain.Controls(intPos).Top, frmmain.ScaleMode, vbPixels) + sngTop
        lngNew = CreateRectRgn(varLeft, varTop, varLeft + frmmain.ScaleX(frmmain.Controls(intPos).Width, frmmain.ScaleMode, vbPixels), varTop + frmmain.ScaleY(frmmain.Controls(intPos).Height, frmmain.ScaleMode, vbPixels))
        CombineRgn lngRegion, lngNew, lngRegion, RGN_OR
    Next
    
    'Redraw the window
    SetWindowRgn frmmain.hwnd, lngRegion, True

End Function

Public Function VisibleForm()

    Dim sngWidth As Single, sngHeight As Single
    
    'Set Form Height And Width To ScaleHeight And ScaleWidth
    sngWidth = frmmain.ScaleX(frmmain.Width, vbTwips, vbPixels)
    sngHeight = frmmain.ScaleY(frmmain.Height, vbTwips, vbPixels)
    
    'Create our region
    lngRegion = CreateRectRgn(0, 0, sngWidth, sngHeight)
    
    'Redraw the window
    SetWindowRgn frmmain.hwnd, lngRegion, True

End Function

Public Function NoFrame()

    Dim sngWidth As Single, sngHeight As Single, sngLeft As Single, sngTop As Single
    Dim varLeft As Variant, varTop As Variant
    Dim intPos As Integer, lngNew As Long, lngIn As Long, lngOut As Long
    
    'Set Form Height And Width To ScaleHeight And ScaleWidth
    sngWidth = frmmain.ScaleX(frmmain.Width, vbTwips, vbPixels)
    sngHeight = frmmain.ScaleY(frmmain.Height, vbTwips, vbPixels)
    
    'Set default region
    lngRegion = CreateRectRgn(0, 0, 0, 0)
    sngLeft = (sngWidth - frmmain.ScaleWidth) / 2
    sngTop = sngHeight - sngLeft - frmmain.ScaleHeight
    
    'We take out getting our window frame because we want it to be an invisible frame
    
    'Add our controls
    For intPos = 0 To frmmain.Controls.Count - 1
        varLeft = frmmain.ScaleX(frmmain.Controls(intPos).Left, frmmain.ScaleMode, vbPixels) + sngLeft
        varTop = frmmain.ScaleX(frmmain.Controls(intPos).Top, frmmain.ScaleMode, vbPixels) + sngTop
        lngNew = CreateRectRgn(varLeft, varTop, varLeft + frmmain.ScaleX(frmmain.Controls(intPos).Width, frmmain.ScaleMode, vbPixels), varTop + frmmain.ScaleY(frmmain.Controls(intPos).Height, frmmain.ScaleMode, vbPixels))
        CombineRgn lngRegion, lngNew, lngRegion, RGN_OR
    Next
    
    'Redraw the window
    SetWindowRgn frmmain.hwnd, lngRegion, True
    
End Function
